/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Cursor;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class BoiteDialogueCreerChamp extends JDialog implements ActionListener{
    
    public FenetrePrincipale fen;
    public Vector columnNames;  // contient les noms des colonnes
    public Vector tableau;  // contient les donnees
    
    
    public BoiteDialogueCreerChamp(FenetrePrincipale f, Vector c, Vector t) {
        super(f, Messages.getString("BoiteDialogueCreerChamp.0"), true);      //$NON-NLS-1$
        this.fen = f;
        this.columnNames = c;
        this.tableau = t;
        
        jLabel = new JLabel();
        bok = new JButton();
        tfCreerChamp = new JTextField();
        jPanel = new JPanel();
        bCancel = new JButton();
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        bok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bokActionPerformed(evt);
            }
        });
        bCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setVisible(false);
                dispose();
            }
        });
                        
        getContentPane().add(jPanel, java.awt.BorderLayout.SOUTH);
        
        bCancel.setText(Messages.getString("BoiteDialogueCreerChamp.1")); //$NON-NLS-1$
        bCancel.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bCancel.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanel.add(bCancel);
        
        bok.setText(Messages.getString("BoiteDialogueCreerChamp.3")); //$NON-NLS-1$
        bok.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        bok.setPreferredSize(new java.awt.Dimension(100, 27));
        jPanel.add(bok);
        
        jLabel.setText(Messages.getString("BoiteDialogueCreerChamp.5"));         //$NON-NLS-1$
        jLabel.setForeground(new java.awt.Color(0, 51, 51));
        jLabel.setFont(new java.awt.Font("Dialog", 0, 12));                 //$NON-NLS-1$
        getContentPane().add(jLabel, java.awt.BorderLayout.NORTH);
        getContentPane().add(tfCreerChamp, java.awt.BorderLayout.CENTER);
        
        pack();
    }
    
    /** Closes the dialog */
    public void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        dispose();
    }
    
    public void afficherBoiteDialogue(){
        this.setLocationRelativeTo(fen);
        this.setVisible(true);
    }        
    
    
    public void bokActionPerformed(java.awt.event.ActionEvent evt){
        this.setCursor(new Cursor(3));
        String champ = "2" + tfCreerChamp.getText();  //recupere le nom du champ é creer //$NON-NLS-1$
        if (champ.compareTo("")==0) { //$NON-NLS-1$
            JOptionPane.showMessageDialog(fen,Messages.getString("BoiteDialogueCreerChamp.9"));}  //controle le champ é saisir //$NON-NLS-1$
        else {fen.afficherTableAjouterCol(champ);         
              setVisible(false);
              dispose();}
        this.setCursor(new Cursor(0));
    }
        
        
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
    }    
    
    // Variables declaration - do not modify
    private javax.swing.JButton bok;
    private javax.swing.JButton bCancel;
    private javax.swing.JLabel jLabel;
    private javax.swing.JTextField tfCreerChamp;
    private javax.swing.JTable table;
    private JPanel jPanel;
 
    // End of variables declaration
    
     
}
