/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.util.Arrays;
import java.util.Vector;

import javax.swing.ButtonGroup;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;

import carto.Carte;
import donnees.champDonnees;

/**
 * @author Laurent
 *  
 */
public class BoiteDialogueSymbolique extends JDialog {

    private FenetrePrincipale base;

    private ButtonGroup bgCouleurs;

    private ButtonGroup bgProportion;

    private ButtonGroup bgType;

    private int caissonSelectionne = 1;

    public Vector colonnes;

    public Vector data;
    
    private boolean initSliders;

    private javax.swing.JButton jbAnnuler;

    private javax.swing.JButton jbCContour;

    private javax.swing.JButton jbCEvides;

    private javax.swing.JButton jbCSymb;

    private javax.swing.JButton jbOk;

    private javax.swing.JButton jButton10;

    private javax.swing.JButton jButton11;

    private javax.swing.JButton jButton12;

    private javax.swing.JButton jButton13;

    private javax.swing.JButton jButton14;

    private javax.swing.JComboBox jcbChamp;

    private javax.swing.JLabel jLabel43;

    private javax.swing.JLabel jLabel44;

    private javax.swing.JLabel jLabel45;

    private javax.swing.JLabel jLabel46;

    private javax.swing.JLabel jLabel47;

    private javax.swing.JLabel jLabel48;

    private javax.swing.JLabel jLabel49;

    private javax.swing.JLabel jlChamp;

    private javax.swing.JLabel jlSurfaceRef;

    private javax.swing.JLabel jlTransp;

    private javax.swing.JLabel jlValRef;

    private javax.swing.JPanel jPanel1;

    private javax.swing.JPanel jPanel2;

    private javax.swing.JPanel jPanel4;

    private javax.swing.JPanel jpCouleurs;

    private PanneauSymbole jpDessin;

    private javax.swing.JPanel jpProportion;

    private javax.swing.JPanel jpSVides;

    private javax.swing.JPanel jpType;

    private javax.swing.JPanel jpValeurDeRef;

    private javax.swing.JRadioButton jrbCVNeg;

    public javax.swing.JRadioButton jrbCVPos;

    private javax.swing.JRadioButton jrbPLineaire;

    private javax.swing.JRadioButton jrbPLog;

    private javax.swing.JRadioButton jrbPRacine;

    private JRadioButton jrbTypeCarre;

    private javax.swing.JRadioButton jrbTypeCercle;

    private javax.swing.JSeparator jSeparator3;

    private javax.swing.JSpinner jspRacine;

    private javax.swing.JSlider jsSurfaceRef;

    private javax.swing.JSpinner jsTransp;

    private javax.swing.JSlider jsValRef;

    private javax.swing.JTabbedPane jTabbedPane1;

    private javax.swing.JTextField jTextField1;

    private javax.swing.JTextField jTextField2;

    private javax.swing.JTextField jTextField24;

    private javax.swing.JTextField jTextField25;

    private javax.swing.JTextField jTextField26;

    private javax.swing.JTextField jtfSurfaceRef;

    private javax.swing.JTextField jtfSVides;

    private javax.swing.JTextField jtfValRef;

    private boolean modif;

	private javax.swing.JRadioButton jrbcm1;
	
	private javax.swing.JRadioButton jrbcm2;
    
	private javax.swing.JRadioButton jrbcm3;

	private javax.swing.ButtonGroup bgcm;
	
    private Carte tempCarte;

    private double[] valeurs;

    public BoiteDialogueSymbolique(FenetrePrincipale parent, boolean modal, String titre, Vector champs, Vector tableau) {
        super(parent, Messages.getString("BoiteDialogueSymbolique.0"), modal); //$NON-NLS-1$
        boolean defaut = false;
        initSliders = true;
        this.setResizable(false);
        this.colonnes = champs;
        this.data = tableau;
        this.base = parent;
        this.tempCarte = new Carte();
        tempCarte = (Carte) base.getCarte().copie();
        //this.tempCarte.setTypeAnalyse(2);
        if (tempCarte.analyseSymb.champNum == -1) {//Valeurs par défaut si pas de carte
            // actuelle.
            int i = 0;
            defaut = true;
            for (i = 0; i < colonnes.size(); i++) {
                int ti = ((champDonnees) colonnes.get(i)).typeI;
                if (ti == 0 || ti == 2) {
                    tempCarte.analyseSymb.champNum = i;
                    break;
                }
            }
            tempCarte.analyseSymb.typeSymbole = 0;
            tempCarte.analyseSymb.surfRef = 3000;
            setDefautCouleurs();
        }
        initComponents();
        valeurs = getValeursTriees();
        jtfSurfaceRef.setText(String.valueOf(tempCarte.analyseSymb.surfRef));       
        jsValRef.setMinimum(0);
        jsValRef.setMaximum(valeurs.length - 1);
        initSliders = false;

        if (defaut == true) {
            updateSource();
        } else {
            jsValRef.setValue((int) Arrays.binarySearch(valeurs, tempCarte.analyseSymb.valeurReference));
            jtfSVides.setText(String.valueOf(tempCarte.analyseSymb.valVide));
            jrbPLineaire.setSelected(tempCarte.analyseSymb.typeProportion == 0);
            jrbPRacine.setSelected(tempCarte.analyseSymb.typeProportion == 1);
            jrbPLog.setSelected(tempCarte.analyseSymb.typeProportion == 2);
        }
        goDessin();
    }

    private void genereCarte() {
        //Génération nouvelle structure de classe Carte
    	tempCarte.analyseSymb.valVide = Double.parseDouble(jtfSVides.getText());
		if (jrbcm1.isSelected()) this.tempCarte.setTypeAnalyse(3);
		if (jrbcm2.isSelected()) this.tempCarte.setTypeAnalyse(4);
		if (jrbcm3.isSelected()) {
			this.tempCarte.setTypeAnalyse(2);
			this.tempCarte.analysePlages.champNum = -1;
		}
		base.carte = null;
        base.carte = tempCarte.copie();
        setVisible(false);
        dispose();
    }

    private double[] getValeursTriees() {
        int i = 0;
        int ni = data.size() / colonnes.size();
        double[] valeurs = new double[ni];
        for (i = 0; i < ni; i++) {
            int position = (i * colonnes.size()) + tempCarte.analyseSymb.champNum;
            if (data.elementAt(position) == null) {
                valeurs[i] = Double.MIN_VALUE;
            } else {
                switch (((champDonnees) colonnes.get(tempCarte.analyseSymb.champNum)).typeI) {
                case 0:
                    valeurs[i] = ((Integer) data.elementAt(position)).doubleValue();
                    break;
                case 2:
                    valeurs[i] = ((Double) data.elementAt(position)).doubleValue();
                    break;
                }
            }
        }
        Arrays.sort(valeurs);
        return valeurs;
    }

    private void goDessin() {
        jpDessin.repaint();
    }

    private void initComponents() {
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jlChamp = new javax.swing.JLabel();
        jcbChamp = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        jpDessin = new PanneauSymbole(this, tempCarte);
        jpType = new javax.swing.JPanel();
        jrbTypeCercle = new javax.swing.JRadioButton();
        jrbTypeCarre = new JRadioButton();
        jpValeurDeRef = new javax.swing.JPanel();
        jlSurfaceRef = new javax.swing.JLabel();
        jtfSurfaceRef = new javax.swing.JTextField();
        jsSurfaceRef = new javax.swing.JSlider();
        jlValRef = new javax.swing.JLabel();
        jtfValRef = new javax.swing.JTextField();
        jsValRef = new javax.swing.JSlider();
        jpProportion = new javax.swing.JPanel();
        jrbPLineaire = new javax.swing.JRadioButton();
        jrbPRacine = new javax.swing.JRadioButton();
        jrbPLog = new javax.swing.JRadioButton();
        jpCouleurs = new javax.swing.JPanel();
        jrbCVPos = new javax.swing.JRadioButton();
        jrbCVNeg = new javax.swing.JRadioButton();
        jbCSymb = new javax.swing.JButton();
        jbCContour = new javax.swing.JButton();
        jbCEvides = new javax.swing.JButton();
        jpSVides = new javax.swing.JPanel();
        jtfSVides = new javax.swing.JTextField();
        jspRacine = new JSpinner();
        jPanel4 = new javax.swing.JPanel();
        jSeparator3 = new javax.swing.JSeparator();
        jLabel43 = new javax.swing.JLabel();
        jLabel44 = new javax.swing.JLabel();
        jLabel45 = new javax.swing.JLabel();
        jLabel46 = new javax.swing.JLabel();
        jLabel47 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        jTextField24 = new javax.swing.JTextField();
        jButton10 = new javax.swing.JButton();
        jButton11 = new javax.swing.JButton();
        jButton12 = new javax.swing.JButton();
        jLabel48 = new javax.swing.JLabel();
        jLabel49 = new javax.swing.JLabel();
        jButton13 = new javax.swing.JButton();
        jTextField25 = new javax.swing.JTextField();
        jTextField26 = new javax.swing.JTextField();
        jButton14 = new javax.swing.JButton();
        bgType = new ButtonGroup();
        bgCouleurs = new ButtonGroup();
        bgProportion = new ButtonGroup();
        jsTransp = new javax.swing.JSpinner();
        jlTransp = new javax.swing.JLabel();
		bgcm = new javax.swing.ButtonGroup();
		jrbcm1 = new javax.swing.JRadioButton();
		jrbcm2 = new javax.swing.JRadioButton();
		jrbcm3 = new javax.swing.JRadioButton();
		int tac = base.carte.getTypeAnalyse();
		if (tac == 0 || tac == 2) {
			jrbcm1.setEnabled(false);
			jrbcm2.setEnabled(false);
		}
        jbAnnuler = new javax.swing.JButton();
        jbOk = new javax.swing.JButton();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jTabbedPane1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel1.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jlChamp.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        jlChamp.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jlChamp.setText(Messages.getString("BoiteDialogueSymbolique.4")); //$NON-NLS-1$
        jlChamp.setAlignmentX(20.0F);
        jPanel1.add(jlChamp, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 100, 50, 20));

        jcbChamp.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        jcbChamp.setToolTipText(Messages.getString("BoiteDialogueSymbolique.6")); //$NON-NLS-1$
        //remplissage combo choix champs
        int i = 0;
        int champSelectionne = 0;
        int compteur = 0;
        for (i = 0; i < colonnes.size(); i++) {
            int ti = ((champDonnees) colonnes.get(i)).typeI;
            if (ti == 0 || ti == 2) {
                compteur += 1;
                jcbChamp.addItem(((champDonnees) colonnes.get(i)).nom);
                if (tempCarte.analyseSymb.champNum != -1 && i == tempCarte.analyseSymb.champNum) {
                    champSelectionne = compteur - 1;
                }
            }
        }
        //sélection si carte en cours
        if (tempCarte.analyseSymb.champNum != -1) {
            jcbChamp.setSelectedIndex(champSelectionne);
        }
        jcbChamp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcbChampActionPerformed(evt);
            }
        });

        jPanel1.add(jcbChamp, new org.netbeans.lib.awtextra.AbsoluteConstraints(130, 100, 197, -1));

        jTabbedPane1.addTab("Champ", jPanel1); //$NON-NLS-1$

        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel2.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jpDessin.setBackground(new java.awt.Color(255, 255, 255));
        jpDessin.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jPanel2.add(jpDessin, new org.netbeans.lib.awtextra.AbsoluteConstraints(210, 6, 180, 180));

        jpType.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jpType.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueSymbolique.9"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, //$NON-NLS-1$
                javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 0, 0))); //$NON-NLS-1$
        jrbTypeCercle.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jrbTypeCercle.setText(Messages.getString("BoiteDialogueSymbolique.12")); //$NON-NLS-1$
        if (tempCarte.analyseSymb.typeSymbole == 0)
            jrbTypeCercle.setSelected(true);
        jrbTypeCercle.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tempCarte.analyseSymb.typeSymbole = 0;
                goDessin();
            }
        });
        bgType.add(jrbTypeCercle);
        jpType.add(jrbTypeCercle, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 18, -1, 18));

        jrbTypeCarre.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jrbTypeCarre.setText(Messages.getString("BoiteDialogueSymbolique.14")); //$NON-NLS-1$
        if (tempCarte.analyseSymb.typeSymbole == 1)
            jrbTypeCarre.setSelected(true);
        jrbTypeCarre.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tempCarte.analyseSymb.typeSymbole = 1;
                goDessin();
            }
        });
        bgType.add(jrbTypeCarre);
        jpType.add(jrbTypeCarre, new org.netbeans.lib.awtextra.AbsoluteConstraints(72, 18, -1, 18));

        jPanel2.add(jpType, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 0, 198, 42));

        jpValeurDeRef.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jpValeurDeRef.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueSymbolique.15"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, //$NON-NLS-1$
                javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 0, 0))); //$NON-NLS-1$
        jlSurfaceRef.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jlSurfaceRef.setText(Messages.getString("BoiteDialogueSymbolique.18")); //$NON-NLS-1$
        jpValeurDeRef.add(jlSurfaceRef, new org.netbeans.lib.awtextra.AbsoluteConstraints(18, 24, -1, 12));

        jtfSurfaceRef.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jpValeurDeRef.add(jtfSurfaceRef, new org.netbeans.lib.awtextra.AbsoluteConstraints(66, 24, 90, 18));

        jsSurfaceRef.setMinimum(10);
        jsSurfaceRef.setMaximum(30000);
        jsSurfaceRef.setValue(tempCarte.analyseSymb.surfRef);
        jsSurfaceRef.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jsSurfaceRefStateChanged(evt);
            }
        });

        jpValeurDeRef.add(jsSurfaceRef, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 42, 180, 20));

        jlValRef.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jlValRef.setText(Messages.getString("BoiteDialogueSymbolique.21")); //$NON-NLS-1$        
        jpValeurDeRef.add(jlValRef, new org.netbeans.lib.awtextra.AbsoluteConstraints(18, 66, -1, 12));

        jtfValRef.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$        
        jpValeurDeRef.add(jtfValRef, new org.netbeans.lib.awtextra.AbsoluteConstraints(66, 66, 90, 18));

        jsValRef.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jsValRefStateChanged(evt);
            }
        });
        jpValeurDeRef.add(jsValRef, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 84, 180, 20));

        jPanel2.add(jpValeurDeRef, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 42, 198, 108));

        jpProportion.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jpProportion.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueSymbolique.23"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, //$NON-NLS-1$
                javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 0, 0))); //$NON-NLS-1$
        jrbPLineaire.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jrbPLineaire.setText(Messages.getString("BoiteDialogueSymbolique.26")); //$NON-NLS-1$
        jrbPLineaire.setSelected(true);
        jrbPLineaire.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tempCarte.analyseSymb.typeProportion = 0;
            }
        });
        bgProportion.add(jrbPLineaire);
        jpProportion.add(jrbPLineaire, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 18, -1, 18));

        jrbPRacine.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jrbPRacine.setText(Messages.getString("BoiteDialogueSymbolique.28")); //$NON-NLS-1$
        jrbPRacine.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tempCarte.analyseSymb.typeProportion = 1;
            }
        });
        bgProportion.add(jrbPRacine);
        jpProportion.add(jrbPRacine, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 42, -1, 18));

        jrbPLog.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jrbPLog.setText(Messages.getString("BoiteDialogueSymbolique.30")); //$NON-NLS-1$
        jrbPLog.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tempCarte.analyseSymb.typeProportion = 2;
            }
        });
        bgProportion.add(jrbPLog);
        jpProportion.add(jrbPLog, new org.netbeans.lib.awtextra.AbsoluteConstraints(78, 18, -1, 18));

        jPanel2.add(jpProportion, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 192, 198, 66));

        jpCouleurs.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jpCouleurs.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueSymbolique.31"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, //$NON-NLS-1$
                javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 0, 0))); //$NON-NLS-1$
        jrbCVPos.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jrbCVPos.setText(Messages.getString("BoiteDialogueSymbolique.34")); //$NON-NLS-1$
        jrbCVPos.setSelected(true);
        jrbCVPos.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                goDessin();
            }
        });
        bgCouleurs.add(jrbCVPos);
        jpCouleurs.add(jrbCVPos, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 14, -1, 18));

        jrbCVNeg.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jrbCVNeg.setText(Messages.getString("BoiteDialogueSymbolique.36")); //$NON-NLS-1$
        jrbCVNeg.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                goDessin();
            }
        });
        bgCouleurs.add(jrbCVNeg);
        jpCouleurs.add(jrbCVNeg, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 30, -1, 18));

        jbCSymb.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jbCSymb.setText(Messages.getString("BoiteDialogueSymbolique.38")); //$NON-NLS-1$
        jbCSymb.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jbCSymb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (jrbCVPos.isSelected() == true) {
                    Color c1 = JColorChooser.showDialog(BoiteDialogueSymbolique.this, Messages.getString("BoiteDialogueSymbolique.39"), tempCarte.analyseSymb.couleurSymbole); //$NON-NLS-1$
                    if (c1 != null)
                        tempCarte.analyseSymb.couleurSymbole = c1;
                } else {
                    Color c1 = JColorChooser.showDialog(BoiteDialogueSymbolique.this, Messages.getString("BoiteDialogueSymbolique.40"), tempCarte.analyseSymb.couleurSymboleNeg); //$NON-NLS-1$
                    if (c1 != null)
                        tempCarte.analyseSymb.couleurSymboleNeg = c1;
                }
                goDessin();
            }
        });
        jpCouleurs.add(jbCSymb, new org.netbeans.lib.awtextra.AbsoluteConstraints(108, 10, 72, 18));

        jbCContour.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jbCContour.setText(Messages.getString("BoiteDialogueSymbolique.42")); //$NON-NLS-1$
        jbCContour.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jbCContour.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (jrbCVPos.isSelected() == true) {
                    Color c1 = JColorChooser.showDialog(BoiteDialogueSymbolique.this, Messages.getString("BoiteDialogueSymbolique.43"), tempCarte.analyseSymb.couleurContour); //$NON-NLS-1$
                    if (c1 != null)
                        tempCarte.analyseSymb.couleurContour = c1;
                } else {
                    Color c1 = JColorChooser.showDialog(BoiteDialogueSymbolique.this, Messages.getString("BoiteDialogueSymbolique.44"), tempCarte.analyseSymb.couleurSymboleNeg); //$NON-NLS-1$
                    if (c1 != null)
                        tempCarte.analyseSymb.couleurContourNeg = c1;
                }
                goDessin();
            }
        });
        jpCouleurs.add(jbCContour, new org.netbeans.lib.awtextra.AbsoluteConstraints(108, 27, 72, 18));

        jbCEvides.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jbCEvides.setText(Messages.getString("BoiteDialogueSymbolique.46")); //$NON-NLS-1$
        jbCEvides.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jbCEvides.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (jrbCVPos.isSelected() == true) {
                    Color c1 = JColorChooser.showDialog(BoiteDialogueSymbolique.this, Messages.getString("BoiteDialogueSymbolique.47"), tempCarte.analyseSymb.couleurEvides); //$NON-NLS-1$
                    if (c1 != null)
                        tempCarte.analyseSymb.couleurEvides = c1;
                } else {
                    Color c1 = JColorChooser.showDialog(BoiteDialogueSymbolique.this, Messages.getString("BoiteDialogueSymbolique.48"), tempCarte.analyseSymb.couleurSymboleNeg); //$NON-NLS-1$
                    if (c1 != null)
                        tempCarte.analyseSymb.couleurEvidesNeg = c1;
                }
                goDessin();
            }
        });
        jpCouleurs.add(jbCEvides, new org.netbeans.lib.awtextra.AbsoluteConstraints(108, 45, 72, 18));

        jsTransp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jsTransp.setModel(new SpinnerNumberModel(tempCarte.analyseSymb.opacite, 0.01, 1, 0.1));
        jsTransp.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                tempCarte.analyseSymb.opacite = ((Double)jsTransp.getValue()).doubleValue();
                goDessin();
            }
        });
        jpCouleurs.add(jsTransp, new org.netbeans.lib.awtextra.AbsoluteConstraints(54, 48, 36, -1));

        jlTransp.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jlTransp.setText(Messages.getString("BoiteDialogueSymbolique.3")); //$NON-NLS-1$
        jpCouleurs.add(jlTransp, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 48, -1, -1));

        jPanel2.add(jpCouleurs, new org.netbeans.lib.awtextra.AbsoluteConstraints(204, 192, 186, 66));

        jspRacine.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jspRacine.setModel(new SpinnerNumberModel(tempCarte.analyseSymb.facteurRacine, 0.01, 10, 0.1));
        jpProportion.add(jspRacine, new org.netbeans.lib.awtextra.AbsoluteConstraints(72, 42, 36, -1));

        jpSVides.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jpSVides.setBorder(new javax.swing.border.TitledBorder(null, Messages.getString("BoiteDialogueSymbolique.50"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, //$NON-NLS-1$
                javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10), new java.awt.Color(0, 0, 0))); //$NON-NLS-1$
        jtfSVides.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jpSVides.add(jtfSVides, new org.netbeans.lib.awtextra.AbsoluteConstraints(66, 18, 90, 18));

        jPanel2.add(jpSVides, new org.netbeans.lib.awtextra.AbsoluteConstraints(6, 150, 198, 42));

        jTabbedPane1.addTab(Messages.getString("BoiteDialogueSymbolique.53"), jPanel2); //$NON-NLS-1$

        /*
         * jPanel4.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
         * 
         * jPanel4.add(jSeparator3, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(0, 130, 390, -1));
         * 
         * jLabel43.setFont(new java.awt.Font("Dialog", 0, 10));
         * jLabel43.setText("Carte :"); jPanel4.add(jLabel43, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));
         * 
         * jLabel44.setFont(new java.awt.Font("Dialog", 0, 10));
         * jLabel44.setText("L\u00e9gende :"); jPanel4.add(jLabel44, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(10, 140, -1, -1));
         * 
         * jLabel45.setFont(new java.awt.Font("Dialog", 0, 10));
         * jLabel45.setText("Titre"); jPanel4.add(jLabel45, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 40, -1, -1));
         * 
         * jLabel46.setFont(new java.awt.Font("Dialog", 0, 10));
         * jLabel46.setText("Sous-titre"); jPanel4.add(jLabel46, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 70, -1, -1));
         * 
         * jLabel47.setFont(new java.awt.Font("Dialog", 0, 10));
         * jLabel47.setText("Date / Source"); jPanel4.add(jLabel47, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 100, -1, -1));
         * 
         * jTextField1.setFont(new java.awt.Font("Dialog", 0, 10));
         * jPanel4.add(jTextField1, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(60, 40, 270, -1));
         * 
         * jTextField2.setFont(new java.awt.Font("Dialog", 0, 10));
         * jPanel4.add(jTextField2, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(80, 70, 250, -1));
         * 
         * jTextField24.setFont(new java.awt.Font("Dialog", 0, 10));
         * jPanel4.add(jTextField24, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(100, 100, 230, -1));
         * 
         * jButton10.setFont(new java.awt.Font("Dialog", 2, 10));
         * jButton10.setText("Fonte"); jButton10.setMargin(new
         * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton10, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 40, 50, 18));
         * 
         * jButton11.setFont(new java.awt.Font("Dialog", 2, 10));
         * jButton11.setText("Fonte"); jButton11.setMargin(new
         * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton11, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 70, 50, 18));
         * 
         * jButton12.setFont(new java.awt.Font("Dialog", 2, 10));
         * jButton12.setText("Fonte"); jButton12.setMargin(new
         * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton12, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 200, 50, 18));
         * 
         * jLabel48.setFont(new java.awt.Font("Dialog", 0, 10));
         * jLabel48.setText("Titre"); jPanel4.add(jLabel48, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 170, -1, -1));
         * 
         * jLabel49.setFont(new java.awt.Font("Dialog", 0, 10));
         * jLabel49.setText("Sous-titre"); jPanel4.add(jLabel49, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(20, 200, -1, -1));
         * 
         * jButton13.setFont(new java.awt.Font("Dialog", 2, 10));
         * jButton13.setText("Fonte"); jButton13.setMargin(new
         * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton13, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 170, 50, 18));
         * 
         * jTextField25.setFont(new java.awt.Font("Dialog", 0, 10));
         * jPanel4.add(jTextField25, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(80, 200, 250, -1));
         * 
         * jTextField26.setFont(new java.awt.Font("Dialog", 0, 10));
         * jPanel4.add(jTextField26, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(60, 170, 270, -1));
         * 
         * jButton14.setFont(new java.awt.Font("Dialog", 2, 10));
         * jButton14.setText("Fonte"); jButton14.setMargin(new
         * java.awt.Insets(2, 2, 2, 2)); jPanel4.add(jButton14, new
         * org.netbeans.lib.awtextra.AbsoluteConstraints(340, 100, 50, 18));
         * 
         * jTabbedPane1.addTab("Habillage", jPanel4);
         */

        getContentPane().add(jTabbedPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 420, 300));
        
		jrbcm1.setSelected(false);
		jrbcm1.setFont(new java.awt.Font("Dialog", 0, 10));
		jrbcm1.setText(Messages.getString("BoiteDialogueSymbolique.58"));
		bgcm.add(jrbcm1);

		getContentPane().add(jrbcm1, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 298, -1, -1));

		jrbcm2.setSelected(false);
		jrbcm2.setFont(new java.awt.Font("Dialog", 0, 10));
		jrbcm2.setText(Messages.getString("BoiteDialogueSymbolique.59"));
		bgcm.add(jrbcm2);
		
		getContentPane().add(jrbcm2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 317, -1, -1));

		jrbcm3.setSelected(true);
		jrbcm3.setFont(new java.awt.Font("Dialog", 0, 10));
		jrbcm3.setText(Messages.getString("BoiteDialogueSymbolique.60"));
		bgcm.add(jrbcm3);

		getContentPane().add(jrbcm3, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 335, -1, -1));

        jbAnnuler.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jbAnnuler.setText(Messages.getString("BoiteDialogueSymbolique.55")); //$NON-NLS-1$
        jbAnnuler.setDefaultCapable(false);
        jbAnnuler.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbAnnulerActionPerformed(evt);
            }
        });
        getContentPane().add(jbAnnuler, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 310, -1, -1));

        jbOk.setFont(new java.awt.Font("Dialog", 0, 10)); //$NON-NLS-1$
        jbOk.setText(Messages.getString("BoiteDialogueSymbolique.57")); //$NON-NLS-1$
        jbOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbOkActionPerformed(evt);
            }
        });
        getContentPane().add(jbOk, new org.netbeans.lib.awtextra.AbsoluteConstraints(342, 310, -1, -1));

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width - 420) / 2, (screenSize.height - 390) / 2, 420, 390);
    }

    private void jbAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        tempCarte = null;
        setVisible(false);
        dispose();
    }

    private void jbOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        genereCarte();
    }

    private void jcbChampActionPerformed(java.awt.event.ActionEvent evt) {
        int i = 0;
        for (i = 0; i < colonnes.size(); i++) {
            if (jcbChamp.getSelectedItem().toString().equals(((champDonnees) colonnes.elementAt(i)).nom)) {
                tempCarte.analyseSymb.champNum = i;
                break;
            }
        }
        valeurs = getValeursTriees();
        jsValRef.setMinimum(0);
        jsValRef.setMaximum(valeurs.length - 1);
        jsValRef.setValue(valeurs.length - 1);
        tempCarte.analyseSymb.surfRef = 3000;
        jtfSurfaceRef.setText(String.valueOf(tempCarte.analyseSymb.surfRef));
        tempCarte.analyseSymb.valeurReference = valeurs[valeurs.length - 1];
        jtfValRef.setText(String.valueOf(valeurs[valeurs.length - 1]));
        jtfSVides.setText(String.valueOf(valeurs[valeurs.length - 1]));
        updateSource();
        goDessin();
    }

    private void jsSurfaceRefStateChanged(ChangeEvent evt) {
        tempCarte.analyseSymb.surfRef = jsSurfaceRef.getValue();
        jtfSurfaceRef.setText(String.valueOf(jsSurfaceRef.getValue()));
        goDessin();
    }

    private void jsValRefStateChanged(ChangeEvent evt) {
        if (jsValRef.getValue() > 0 && initSliders == false)
            tempCarte.analyseSymb.valeurReference = valeurs[jsValRef.getValue()];
        jtfValRef.setText(String.valueOf(valeurs[jsValRef.getValue()]));
    }

    private void setDefautCouleurs() {
        tempCarte.analyseSymb.couleurSymbole = new Color(102, 150, 102);;
        tempCarte.analyseSymb.couleurContour = new Color(152, 255, 152);;
        tempCarte.analyseSymb.couleurSymboleNeg = new Color(100, 220, 100);
        tempCarte.analyseSymb.couleurContourNeg = new Color(10, 100, 10);
        tempCarte.analyseSymb.couleurEvides = new Color(10, 60, 10);
    }

    private void updateSource() {
        int i = 0;
        int position = 0;
        int minIndex = 0;
        while (valeurs[minIndex] == Double.MIN_VALUE) {
        	minIndex++;
        }
        tempCarte.analyseSymb.legMinValeur = valeurs[minIndex];
        tempCarte.analyseSymb.legMedValeur = valeurs[(int) (valeurs.length / 2)];
        tempCarte.analyseSymb.legMaxValeur = valeurs[valeurs.length - 1];
        tempCarte.analyseSymb.legMinIndex = valeurs.length + 1;
        tempCarte.analyseSymb.legMedIndex = valeurs.length + 1;
        tempCarte.analyseSymb.legMaxIndex = valeurs.length + 1;
        int typeChamp = ((champDonnees) colonnes.elementAt(tempCarte.analyseSymb.champNum)).typeI;
        for (i = 0; i < valeurs.length; i++) {
            position = (i * colonnes.size()) + tempCarte.analyseSymb.champNum;
            if (data.elementAt(position) == null) continue;
            switch (typeChamp) {
            case 0:
                if (((Integer) data.elementAt(position)).doubleValue() == valeurs[minIndex])
                    tempCarte.analyseSymb.legMinIndex = i;
                if (((Integer) data.elementAt(position)).doubleValue() == valeurs[(int) (valeurs.length / 2)])
                    tempCarte.analyseSymb.legMedIndex = i;
                if (((Integer) data.elementAt(position)).doubleValue() == valeurs[valeurs.length - 1])
                    tempCarte.analyseSymb.legMaxIndex = i;
                break;
            case 2:
                if (((Double) data.elementAt(position)).doubleValue() == valeurs[minIndex])
                    tempCarte.analyseSymb.legMinIndex = i;
                if (((Double) data.elementAt(position)).doubleValue() == valeurs[(int) (valeurs.length / 2)])
                    tempCarte.analyseSymb.legMedIndex = i;
                if (((Double) data.elementAt(position)).doubleValue() == valeurs[valeurs.length - 1])
                    tempCarte.analyseSymb.legMaxIndex = i;
                break;
            }
        }
        jsValRef.setValue(valeurs.length - 1);
        jtfSVides.setText(String.valueOf(valeurs[valeurs.length - 1]));
        jrbPLineaire.setSelected(true);
    }

}