/*
 * 8 avril 2007
 * 
 * SCAP-J - Système de Cartographie Automatique pour la Pédagogie - Java
 * Version beta 0.94
 *
 * Copyright 1997-2004 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excel©)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confère
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modèle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs à la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * L’accessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de n’offrir aux utilisateurs qu’une garantie limitée et de ne faire peser sur l’auteur
 * le titulaire des droits patrimoniaux et les concédants successifs qu’une responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou à l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;

//import javax.media.j3d.Transform3D;
//import javax.media.j3d.TransformGroup;
import javax.swing.ImageIcon;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import com.sun.j3d.utils.behaviors.mouse.MouseBehaviorCallback;

import carto.Carte;
import donnees.NullRenderer;
import donnees.NullTableCellEditor;
import donnees.TableModel;
import donnees.TableSorter;

public class FenetreMilieu extends JDesktopPane implements ActionListener {

	private FenetrePrincipale base;

	//definit le positionnement de la prochaine fenêtre
	private int fenetreSuivX;

	private int fenetreSuivY;

	private int distanceFenetre;

	public static Vector columnNames; //champDonnees

	public static Object[][] tableau;

	public static Vector data;

	protected boolean ordre;

	public JTable jtableau;

	public FenetreCarte fenetre;

	public FenetreLegende fenLegende;

	public FenetreMiseEnPage fenMEP;

	private int nbFen3D;

	//public Fenetre3D fen3D;

	//public Fenetre3D fen3D2;

//	private Transform3D rotation;

	public FenetreMilieu(FenetrePrincipale labase) {
		this.base = labase;
		this.setVisible(true);
	}

	public FenetreCarte getFenetreCarte() {
		return fenetre;
	}

	public void creerFenetreCarte(FenetrePrincipale labase, String titre, String fond) {
		this.base = labase;
		
		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		this.fenetre = new FenetreCarte(this, Messages.getString("FenetreMilieu.0"), "ouverture", fond); //$NON-NLS-1$ //$NON-NLS-2$
		this.add(fenetre);
		this.fenetre.setBackground(new Color(255, 255, 255));

		//positionnement et dimensionnement de la fenetre
		this.fenetre.reshape(fenetreSuivX, fenetreSuivY, largeur, hauteur);
		this.fenetre.show();

		// sélectionne la fenêtre (peut être refusé)
		try {
			fenetre.setSelected(true);
		} catch (Exception e) {

		}
		;

		// calcul de la distance qu'il doit y avoir entre les fenetres en
		// cascade
		if (distanceFenetre == 0)
			distanceFenetre = fenetre.getHeight() - fenetre.getContentPane().getHeight();

		//calcul de l'emplacement de la prochaine fenetre
		fenetreSuivX += distanceFenetre;
		fenetreSuivY += distanceFenetre;
		if (fenetreSuivX + largeur > this.getWidth())
			fenetreSuivX = 0;
		if (fenetreSuivY + hauteur > this.getHeight())
			fenetreSuivY = 0;
	}

	public void creerFenetreMEP(JFrame fp) {
		fenMEP = new FenetreMiseEnPage(this, fp);
		ImageIcon icone = new ImageIcon("icones\\petiteicone.png"); //$NON-NLS-1$
		fenMEP.setFrameIcon(icone);
		Font f = new Font("SansSerif", Font.PLAIN, 24); //$NON-NLS-1$
		fenMEP.setFont(f);

		//ajout de la fenetre au bureau
		this.add(fenMEP);
		fenMEP.show();
		fenMEP.getContentPane().setPreferredSize(this.getSize());
		this.validate();
	}

/*	public void creerFenetre3D(JFrame fp) {
		if (nbFen3D == 1) {
			fen3D2 = new Fenetre3D(this, fp, 2);
			ImageIcon icone = new ImageIcon("icones\\petiteicone.png"); //$NON-NLS-1$
			fen3D2.setFrameIcon(icone);
			Font f = new Font("SansSerif", Font.PLAIN, 24); //$NON-NLS-1$

			//ajout de la fenétre au bureau
			this.add(fen3D2);
			fen3D2.show();
			fen3D2.getContentPane().setPreferredSize(this.getSize());
			base.itemCarte3d.setEnabled(false);
			this.fen3D.getJCB3().setEnabled(true);
			this.nbFen3D = 2;
		}
		if (nbFen3D == 0) {
			this.rotation = new Transform3D();
			fen3D = new Fenetre3D(this, fp, 1);
			ImageIcon icone = new ImageIcon("icones\\petiteicone.png"); //$NON-NLS-1$
			fen3D.setFrameIcon(icone);
			Font f = new Font("SansSerif", Font.PLAIN, 24); //$NON-NLS-1$

			//ajout de la fenétre au bureau
			this.add(fen3D);
			fen3D.show();
			fen3D.getContentPane().setPreferredSize(this.getSize());
			nbFen3D = 1;
		}
		this.validate();
	}*/

	public void creerFenetreLegende(Carte carte) {
		fenLegende = new FenetreLegende(carte, this.getFenetreCarte().panneauCarte.getFondCarte());
		this.add(fenLegende);
		fenLegende.show();
	}

	public void creerFenetreCarteMIF(FenetrePrincipale labase, String titre, String fond) {
		this.base = labase;
		
		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		this.fenetre = new FenetreCarte(this, Messages.getString("FenetreMilieu.4"), "importation", fond); //$NON-NLS-1$ //$NON-NLS-2$
		this.add(fenetre);
		this.fenetre.setBackground(new Color(255, 255, 255));

		//positionnement et dimensionnement de la fenetre
		this.fenetre.reshape(fenetreSuivX, fenetreSuivY, largeur, hauteur);
		this.fenetre.show();

		// sélectionne la fenêtre (peut être refusé)
		try {
			fenetre.setSelected(true);
		} catch (Exception e) {

		}
		;

		// calcul de la distance qu'il doit y avoir entre les fenetres en
		// cascade
		if (distanceFenetre == 0)
			distanceFenetre = fenetre.getHeight() - fenetre.getContentPane().getHeight();

		//calcul de l'emplacement de la prochaine fenetre
		fenetreSuivX += distanceFenetre;
		fenetreSuivY += distanceFenetre;
		if (fenetreSuivX + largeur > this.getWidth())
			fenetreSuivX = 0;
		if (fenetreSuivY + hauteur > this.getHeight())
			fenetreSuivY = 0;
	}

	//affiche dans une JInternalFrame les données lorsque l'utilisateur ouvre
	// un nouveau fichier
	public void creerFenetreDonnees(FenetrePrincipale base, String nomFichier) {
		this.base = base;

		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		TableModel tabouv = new TableModel("ouvrir", nomFichier); //$NON-NLS-1$

		data = tabouv.getData();
		//tableau = tabouv.getTableau();
		columnNames = tabouv.getColumnNames();

		//création de la fenetre contenant les données
		JInternalFrame fen = new JInternalFrame(Messages.getString("FenetreMilieu.7"), true, true, true, true); //$NON-NLS-1$

		ImageIcon icone = new ImageIcon("icones\\petiteicone.png"); //$NON-NLS-1$
		fen.setFrameIcon(icone);
		Font f = new Font("SansSerif", Font.PLAIN, 24); //$NON-NLS-1$
		fen.setFont(f);

		//Tri désactivé car recherche valeur fausse.
		//TableSorter sorter = new TableSorter(tabouv);
		jtableau = new JTable(tabouv);
		//sorter.setTableHeader(jtableau.getTableHeader());
		jtableau.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		//jtableau.getTableHeader().setToolTipText("Click to specify sorting;
		// Control-Click to specify secondary sorting");
		jtableau.setDefaultRenderer(String.class, new NullRenderer());
		jtableau.setDefaultRenderer(Double.class, new NullRenderer());
		jtableau.setDefaultRenderer(Integer.class, new NullRenderer());
		jtableau.setDefaultEditor(Integer.class, new NullTableCellEditor());

		//scroller
		JScrollPane scrollPane = new JScrollPane(jtableau);
		scrollPane.setWheelScrollingEnabled(true);
		fen.getContentPane().add(scrollPane);

		fen.setSize(800, 800);
		fen.setClosable(false);

		//ajout de la fenetre au bureau
		this.add(fen);
		this.validate();

		fen.setForeground(Color.black);
		fen.setBackground(Color.lightGray);
		fen.reshape(fenetreSuivX, fenetreSuivY, largeur, hauteur);
		fen.show();

		jtableau.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				reagitClic(evt,jtableau);
			}
		});

		/*
		 * jtableau=tabouv.getJTable();
		 * 
		 * jtableau.addKeyListener(new KeyAdapter() { public void
		 * keyPressed(KeyEvent evt) { modifCellJTable(evt,jtableau); }});
		 */

		// sélectionne la fenêtre (peut être refusé)
		try {
			fen.setSelected(true);
		} catch (Exception e) {

		};

		// calcul de la distance qu'il doit y avoir entre les fenetres en
		// cascade
		if (distanceFenetre == 0)
			distanceFenetre = fen.getHeight() - fen.getContentPane().getHeight();

		//calcul de l'emplacement de la prochaine fenetre
		fenetreSuivX += distanceFenetre;
		fenetreSuivY += distanceFenetre;
		if (fenetreSuivX + largeur > this.getWidth())
			fenetreSuivX = 0;
		if (fenetreSuivY + hauteur > this.getHeight())
			fenetreSuivY = 0;

	}

	//affiche dans une JInternalFrame les données lorsque l'utilisateur ouvre
	// un nouveau fichier
	public void creerFenetreDonneesMID(String nomFichier) {

		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;
		//columnNames=new Object[2];
		//tableau=new Object[10000][10];

		//TableModelOuvrir tabouv=new TableModelOuvrir(nomFichier);
		TableModel tmm = new TableModel("importerMID", nomFichier); //$NON-NLS-1$

		//tableau = tmm.getTableau();
		columnNames = tmm.getColumnNames();
		data = tmm.getData();

		//création de la fenetre contenant les données
		JInternalFrame fen = new JInternalFrame(Messages.getString("FenetreMilieu.11"), true, true, true, true); //$NON-NLS-1$

		ImageIcon icone = new ImageIcon("icones\\petiteicone.png"); //$NON-NLS-1$
		fen.setFrameIcon(icone);
		Font f = new Font("SansSerif", Font.PLAIN, 24); //$NON-NLS-1$
		fen.setFont(f);

		TableSorter sorter = new TableSorter(tmm);
		jtableau = new JTable(sorter);
		sorter.setTableHeader(jtableau.getTableHeader());
		jtableau.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		jtableau.getTableHeader().setToolTipText(Messages.getString("FenetreMilieu.14")); //$NON-NLS-1$
		jtableau.setDefaultRenderer(String.class, new NullRenderer());
		jtableau.setDefaultRenderer(Double.class, new NullRenderer());
		jtableau.setDefaultRenderer(Integer.class, new NullRenderer());

		//scroller
		JScrollPane scrollPane = new JScrollPane(jtableau);
		scrollPane.setWheelScrollingEnabled(true);
		fen.getContentPane().add(scrollPane);

		fen.setSize(800, 800);
		fen.setClosable(false);

		//ajout de la fenetre au bureau
		this.add(fen);

		fen.setForeground(Color.black);
		fen.setBackground(Color.lightGray);

		fen.reshape(fenetreSuivX, fenetreSuivY, largeur, hauteur);
		fen.show();

		jtableau.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				reagitClic(evt, jtableau);
			}
		});

		/*
		 * jtableau=tabouv.getJTable();
		 * 
		 * jtableau.addKeyListener(new KeyAdapter() { public void
		 * keyPressed(KeyEvent evt) { modifCellJTable(evt,jtableau); }});
		 */

		// sélectionne la fenêtre (peut être refusé)
		try {
			fen.setSelected(true);
		} catch (Exception e) {
		}
		;

		// calcul de la distance qu'il doit y avoir entre les fenetres en
		// cascade
		if (distanceFenetre == 0)
			distanceFenetre = fen.getHeight() - fen.getContentPane().getHeight();

		//calcul de l'emplacement de la prochaine fenetre
		fenetreSuivX += distanceFenetre;
		fenetreSuivY += distanceFenetre;
		if (fenetreSuivX + largeur > this.getWidth())
			fenetreSuivX = 0;
		if (fenetreSuivY + hauteur > this.getHeight())
			fenetreSuivY = 0;
	}

	//créer un fichier texte de sauvegarde des données
	public void creerFenetreEnregistrer(String nomFichier) {
		TableModel tabenr = new TableModel("enregistrer", nomFichier, data, columnNames); //$NON-NLS-1$
		tableau = tabenr.getTableau();
		columnNames = tabenr.getColumnNames();
		data = tabenr.getData();
	}

	public void creeFenetreDonneesImportXLS(Vector c, Vector t, Vector newC, Vector newT) {
		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		TableModel tabImportXLS = new TableModel("importXLS", c, t, newC, newT); //$NON-NLS-1$

		//tableau = tabajout.getTableau();
		data = tabImportXLS.getData();
		columnNames = tabImportXLS.getColumnNames();

		JInternalFrame tab = new JInternalFrame("future données", true, true, true, true); //$NON-NLS-1$
		this.add(tab);
		tab.setForeground(Color.black);
		tab.setBackground(Color.lightGray);
		jtableau = new JTable(tabImportXLS);
		jtableau.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		jtableau.setDefaultRenderer(String.class, new NullRenderer());
		jtableau.setDefaultRenderer(Double.class, new NullRenderer());
		jtableau.setDefaultRenderer(Integer.class, new NullRenderer());

		JScrollPane scrollPane = new JScrollPane(jtableau);
		scrollPane.setWheelScrollingEnabled(true);
		tab.getContentPane().add(scrollPane);

		jtableau.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				reagitClic(evt,jtableau);
			}
		});        

		JInternalFrame[] fenetres = this.getAllFrames();
		int i = 0;
		Point position = new Point(0, 0);
		Dimension taille = new Dimension(0, 0);
		for (i = 0; i < fenetres.length; i++) {
			String title = fenetres[i].getTitle();
			if (title.equals(Messages.getString("FenetreMilieu.18"))) { //$NON-NLS-1$
				position = fenetres[i].getLocation();
			taille = fenetres[i].getSize();
			fenetres[i].setVisible(false);
			fenetres[i].dispose();
			}
		}
		tab.setTitle(Messages.getString("FenetreMilieu.19")); //$NON-NLS-1$
		tab.setLocation(position);
		tab.setSize(taille);
		tab.setVisible(true);
		tab.show();
	}

	//affiche les données lorsque l'utilisateur supprime un champ dans le
	// tableau
	public void creerFenetreSupprCol(String titre, int champ) {
		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		TableModel tmsc = new TableModel("suppr.champ", champ, data, columnNames); //$NON-NLS-1$
		data = tmsc.getData();
		tableau = tmsc.getTableau();
		columnNames = tmsc.getColumnNames();
		JInternalFrame fen = new JInternalFrame("future données", true, true, true, true); //$NON-NLS-1$
		Font f = new Font("SansSerif", Font.PLAIN, 24); //$NON-NLS-1$
		fen.setFont(f);
		jtableau = new JTable(tmsc);
		jtableau.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		jtableau.setDefaultRenderer(String.class, new NullRenderer());
		jtableau.setDefaultRenderer(Double.class, new NullRenderer());
		jtableau.setDefaultRenderer(Integer.class, new NullRenderer());

		//scroller
		JScrollPane scrollPane = new JScrollPane(jtableau);
		scrollPane.setWheelScrollingEnabled(true);
		fen.getContentPane().add(scrollPane);

		this.add(fen);
		fen.setForeground(Color.black);
		fen.setBackground(Color.lightGray);
		JInternalFrame[] fenetres = this.getAllFrames();
		int i = 0;
		Point position = new Point(0, 0);
		Dimension taille = new Dimension(0, 0);
		for (i = 0; i < fenetres.length; i++) {
			String title = fenetres[i].getTitle();
			if (title.equals(Messages.getString("FenetreMilieu.1"))) { //$NON-NLS-1$
				position = fenetres[i].getLocation();
				taille = fenetres[i].getSize();
				fenetres[i].setVisible(false);
				fenetres[i].dispose();
			}
		}
		fen.setTitle(Messages.getString("FenetreMilieu.24")); //$NON-NLS-1$
		fen.setLocation(position);
		fen.setSize(taille);
		fen.setVisible(true);
		fen.show();
	}

	//affiche les données lorsque l'utilisateur ajoute un champ vide dans le
	// tableau
	public void creerFenetreAjouterCol(String titre, String champ) {
		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		TableModel tabajout = new TableModel("creeChamp", champ, data, columnNames); //$NON-NLS-1$

		//tableau = tabajout.getTableau();
		data = tabajout.getData();
		columnNames = tabajout.getColumnNames();

		JInternalFrame tab = new JInternalFrame("future données", true, true, true, true); //$NON-NLS-1$
		this.add(tab);
		tab.setForeground(Color.black);
		tab.setBackground(Color.lightGray);
		jtableau = new JTable(tabajout);
		jtableau.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		jtableau.setDefaultRenderer(String.class, new NullRenderer());
		jtableau.setDefaultRenderer(Double.class, new NullRenderer());
		jtableau.setDefaultRenderer(Integer.class, new NullRenderer());

		//scroller
		JScrollPane scrollPane = new JScrollPane(jtableau);
		scrollPane.setWheelScrollingEnabled(true);
		tab.getContentPane().add(scrollPane);
		JInternalFrame[] fenetres = this.getAllFrames();
		int i = 0;
		Point position = new Point(0, 0);
		Dimension taille = new Dimension(0, 0);
		for (i = 0; i < fenetres.length; i++) {
			String title = fenetres[i].getTitle();
			if (title.equals(Messages.getString("FenetreMilieu.27"))) { //$NON-NLS-1$
				position = fenetres[i].getLocation();
				taille = fenetres[i].getSize();
				fenetres[i].setVisible(false);
				fenetres[i].dispose();
			}
		}
		tab.setTitle(Messages.getString("FenetreMilieu.28")); //$NON-NLS-1$
		tab.setLocation(position);
		tab.setSize(taille);
		tab.setVisible(true);
		tab.show();
	}

	//affiche les données lorsque l'utilisateur calcul un nouveau champ
	public void creerFenetreCalculerChp(String champAcreer, String formule) {

		TableModel tabCC = new TableModel("calulerChamp", champAcreer, data, columnNames, formule); //$NON-NLS-1$
		data = tabCC.getData();
		columnNames = tabCC.getColumnNames();
		JInternalFrame tab = new JInternalFrame("future données", true, true, true, true); //$NON-NLS-1$
		this.add(tab);
		tab.setForeground(Color.black);
		tab.setBackground(Color.lightGray);
		
		jtableau = new JTable(tabCC);
		jtableau.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		jtableau.setDefaultRenderer(String.class, new NullRenderer());
		jtableau.setDefaultRenderer(Double.class, new NullRenderer());
		jtableau.setDefaultRenderer(Integer.class, new NullRenderer());

		JScrollPane scrollPane = new JScrollPane(jtableau);
		scrollPane.setWheelScrollingEnabled(true);
		tab.getContentPane().add(scrollPane);

		jtableau.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				reagitClic(evt,jtableau);
			}
		});        

		JInternalFrame[] fenetres = this.getAllFrames();
		int i = 0;
		Point position = new Point(0, 0);
		Dimension taille = new Dimension(0, 0);
		for (i = 0; i < fenetres.length; i++) {
			String title = fenetres[i].getTitle();
			if (title.equals(Messages.getString("FenetreMilieu.18"))) { //$NON-NLS-1$
				position = fenetres[i].getLocation();
			taille = fenetres[i].getSize();
			fenetres[i].setVisible(false);
			fenetres[i].dispose();
			}
		}
		tab.setTitle(Messages.getString("FenetreMilieu.19")); //$NON-NLS-1$
		tab.setLocation(position);
		tab.setSize(taille);
		tab.setVisible(true);
		tab.show();
	}

	/** ********************************************************************** */

	//affiche les données lorsque l'utilisateur désire centrer et réduire un
	// champ du tableau
	public void creerFenetreCentrerReduireCol(String titre, String champ, String champAcreer) {
		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		TableModel tabCR = new TableModel("centrage_reduction", champ, champAcreer, data, columnNames); //$NON-NLS-1$
		data = tabCR.getData();
		columnNames = tabCR.getColumnNames();
		jtableau = new JTable(tabCR);
		jtableau.setDefaultRenderer(String.class, new NullRenderer());
		jtableau.setDefaultRenderer(Double.class, new NullRenderer());
		jtableau.setDefaultRenderer(Integer.class, new NullRenderer());

		JInternalFrame fen = new JInternalFrame("future données", true, true, true, true); //$NON-NLS-1$

		Font f = new Font("SansSerif", Font.PLAIN, 24); //$NON-NLS-1$
		fen.setFont(f);
		fen.setSize(500, 500);
		this.add(fen);
		fen.setForeground(Color.black);
		fen.setBackground(Color.lightGray);

		//scroller
		JScrollPane scrollPane = new JScrollPane(jtableau);
		scrollPane.setWheelScrollingEnabled(true);
		fen.getContentPane().add(scrollPane);
		JInternalFrame[] fenetres = this.getAllFrames();
		int i = 0;
		Point position = new Point(0, 0);
		Dimension taille = new Dimension(0, 0);
		for (i = 0; i < fenetres.length; i++) {
			String title = fenetres[i].getTitle();
			if (title.equals(Messages.getString("FenetreMilieu.36"))) { //$NON-NLS-1$
				position = fenetres[i].getLocation();
				taille = fenetres[i].getSize();
				fenetres[i].setVisible(false);
				fenetres[i].dispose();
			}
		}
		fen.setTitle(Messages.getString("FenetreMilieu.37")); //$NON-NLS-1$
		fen.setLocation(position);
		fen.setSize(taille);
		fen.setVisible(true);
		fen.show();
	}

	/** ********************************************************************** */

	//affiche les données lorsque l'utilisateur veut faire une projection
	public void creerFenetreProjeter(String champACreer, String varR1, String varR2, int ecartAnneesR, int ecartAnneesProj) {
		int largeur = this.getWidth() / 2;
		int hauteur = this.getHeight() / 2;

		//TableModel tabProj = new TableModel("projection", champACreer, data, columnNames, varR1, varR2, ecartAnneesR, ecartAnneesProj); //$NON-NLS-1$

		//tableau = tabProj.getTableau();
		//columnNames = tabProj.getColumnNames();

		//JInternalFrame tab=tabProj.creerTableau("Données [**]");
		JInternalFrame tab = new JInternalFrame();

		this.add(tab);

		tab.setSize(500, 500);

		tab.setForeground(Color.black);
		tab.setBackground(Color.lightGray);

		tab.setVisible(true);

		tab.show();

		JInternalFrame[] fenetres = this.getAllFrames();
		int i = 0;

		for (i = 0; i < fenetres.length; i++) {
			String title = fenetres[i].getTitle();
			if ((title.compareTo(Messages.getString("FenetreMilieu.39")) == 0) || (title.compareTo(Messages.getString("FenetreMilieu.40")) == 0)) { //$NON-NLS-1$ //$NON-NLS-2$
				fenetres[i].setVisible(false);
			} else {
				fenetres[i].show();
				fenetres[i].setTitle(Messages.getString("FenetreMilieu.41")); //$NON-NLS-1$
			}
		}

	}

	/** ********************************************************************** */

	public void fenetreCascade() {
		JInternalFrame[] fenetres = this.getAllFrames();
		int x = 0;
		int y = 0;
		int largeur = this.getWidth();
		int longueur = this.getHeight();

		for (int i = 0; i < fenetres.length; i++) {
			if (!fenetres[i].isIcon()) {
				try {
					fenetres[i].setMaximum(false);
					fenetres[i].reshape(x, y, largeur, longueur);

					x += distanceFenetre;
					y += distanceFenetre;

					if (x + largeur > this.getWidth())
						x = 0;
					if (y + longueur > this.getHeight())
						y = 0;
				} catch (Exception e) {
				}
			}
		}
	}

	/** *********************************************************************** */

	public void fenetreMosaique() {
		JInternalFrame[] fenetres = this.getAllFrames();

		int cptrFenetres = 0;
		for (int i = 0; i < fenetres.length; i++) {
			if (!fenetres[i].isIcon())
				cptrFenetres++;
		}
		int lignes = (int) Math.sqrt(cptrFenetres);
		int colonnes = cptrFenetres / lignes;
		int extra = cptrFenetres % lignes;

		int largeur = this.getWidth() / colonnes;
		int hauteur = this.getHeight() / lignes;
		int l = 0;
		int c = 0;

		for (int i = 0; i < fenetres.length; i++) {
			if (!fenetres[i].isIcon()) {
				try {
					fenetres[i].setMaximum(false);
					fenetres[i].reshape(c * largeur, l * hauteur, largeur, hauteur);

					l++;
					if (l == lignes) {
						l = 0;
						c++;
						if (c == colonnes - extra) {
							lignes++;
							hauteur = this.getHeight() / lignes;
						}
					}
				} catch (Exception e) {
				}
			}
		}
	}

	// Méthode d'accès à l'attribut columnNames
	public Vector getColumnNames() {
		return (columnNames);
	}

	// Méthode d'accès à l'attribut tableau
	public Vector getTableau() {
		return (data);
	}

	public Vector getDataVector() {
		return (data);
	}

	//Récupération du numéro de ligne et de colonne de la cellule sélectionnée
	// par l'utilisateur
	private void reagitClic(MouseEvent evt, JTable jtableau) {
		int numLigneSel = jtableau.getSelectedRow();
		base.getPanneauCentral().getFenetreCarte().getPanneauCarte().getFondCarte().setPSel(numLigneSel);
		base.getPanneauCentral().getFenetreCarte().getPanneauCarte().repaint();
	}

	// méthode qui permet de mettre à jour l'attribut tableau si l'utilisateur
	// réalise une
	// modification sur la JTable (inutile car semble être géré automatiquement
	// par la JTable
	/*
	 * private void modifCellJTable(KeyEvent evt,JTable jtableau) { int
	 * numLigneSel=jtableau.getSelectedRow(); int
	 * numColSel=jtableau.getSelectedColumn();
	 * 
	 * char val=evt.getKeyChar(); int code=evt.getKeyCode();
	 * System.out.println("co:"+code);
	 * 
	 * if ( (code==evt.VK_ENTER)||(code==evt.VK_TAB) ) {
	 * jtableau.setValueAt(newCellVal,numLigneSel,numColSel); newCellVal="";
	 * Object newVal=jtableau.getValueAt(numLigneSel,numColSel);
	 * System.out.println("newval:"+newVal);} else {newCellVal=newCellVal+val;} }
	 */

	public void actionPerformed(ActionEvent evt) {

	}

	public int chercheGeoCode(String geoCode) {
		int i = 0;
		for (i = 0; i < jtableau.getRowCount(); i++) {
			if (((String) jtableau.getValueAt(i, 0)).equals(geoCode))
				return i;
		}
		return -1;
	}

	public FenetrePrincipale getBase() {
		return base;
	}

/*	public int getNbFen3D() {
		return nbFen3D;
	}

	public Transform3D getRotation() {
		return rotation;
	}

	public void setRotation(Transform3D rotation) {
		this.rotation = rotation;
	}

	public void setNbFen3D(int nbFen3D) {
		this.nbFen3D = nbFen3D;
	}*/
}