/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Dimension;
import java.awt.event.ActionListener;

public class PanneauDroite extends javax.swing.JPanel implements ActionListener {

    /** Creates a new instance of PanneauDroite */
    public PanneauDroite() {
        initPanneauDroite();
        this.setVisible(true);
    }

    public void initPanneauDroite() {

        labelselect = new javax.swing.JLabel();
        tfSelect = new javax.swing.JTextField();
        panneauChoro = new javax.swing.JPanel();
        labelChoro = new javax.swing.JLabel();
        sliderChoro = new javax.swing.JSlider();
        bDefaut = new javax.swing.JButton();
        bRouges = new javax.swing.JButton();
        bQuantiles = new javax.swing.JButton();
        bVerts = new javax.swing.JButton();
        bMoyemb = new javax.swing.JButton();
        bGris = new javax.swing.JButton();
        panneauSymb = new javax.swing.JPanel();
        labelSymb = new javax.swing.JLabel();
        sliderSymb = new javax.swing.JSlider();
        bCercles = new javax.swing.JButton();
        bCarres = new javax.swing.JButton();
        bPLineaire = new javax.swing.JButton();
        bPRacine = new javax.swing.JButton();
        bPLog = new javax.swing.JButton();

        this.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));
        this.setBackground(new java.awt.Color(0, 204, 204));
        this.setPreferredSize(new Dimension(140, 10));

        labelselect.setText(Messages.getString("PanneauDroite.0")); //$NON-NLS-1$
        labelselect.setForeground(new java.awt.Color(0, 51, 51));
        labelselect.setFont(new java.awt.Font("Dialog", 0, 12)); //$NON-NLS-1$
        this.add(labelselect);

        tfSelect.setColumns(12);
        this.add(tfSelect);

        panneauChoro.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        panneauChoro.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        panneauChoro.setBackground(new java.awt.Color(0, 204, 204));
        panneauChoro.setPreferredSize(new java.awt.Dimension(130, 160));
        labelChoro.setText(Messages.getString("PanneauDroite.2")); //$NON-NLS-1$
        labelChoro.setForeground(new java.awt.Color(0, 51, 51));
        labelChoro.setBackground(new java.awt.Color(204, 204, 255));
        labelChoro.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        labelChoro.setPreferredSize(new java.awt.Dimension(120, 23));
        labelChoro.setOpaque(true);
        panneauChoro.add(labelChoro);

        sliderChoro.setMinorTickSpacing(1);
        sliderChoro.setPaintLabels(true);
        sliderChoro.setPaintTicks(true);
        sliderChoro.setMinimum(2);
        sliderChoro.setMajorTickSpacing(1);
        sliderChoro.setMaximum(8);
        sliderChoro.setForeground(new java.awt.Color(51, 51, 0));
        sliderChoro.setBackground(new java.awt.Color(204, 255, 255));
        sliderChoro.setValue(5);
        sliderChoro.setFont(new java.awt.Font("Dialog", 1, 12)); //$NON-NLS-1$
        sliderChoro.setPreferredSize(new java.awt.Dimension(120, 45));
        panneauChoro.add(sliderChoro);

        bDefaut.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bDefaut.setText(Messages.getString("PanneauDroite.5")); //$NON-NLS-1$
        bDefaut.setBackground(new java.awt.Color(204, 255, 255));
        bDefaut.setPreferredSize(new java.awt.Dimension(56, 20));
        bDefaut.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bDefaut.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauChoro.add(bDefaut);

        bRouges.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bRouges.setText(Messages.getString("PanneauDroite.7")); //$NON-NLS-1$
        bRouges.setBackground(new java.awt.Color(204, 255, 255));
        bRouges.setPreferredSize(new java.awt.Dimension(56, 20));
        bRouges.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bRouges.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauChoro.add(bRouges);

        bQuantiles.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bQuantiles.setText(Messages.getString("PanneauDroite.9")); //$NON-NLS-1$
        bQuantiles.setBackground(new java.awt.Color(204, 255, 255));
        bQuantiles.setPreferredSize(new java.awt.Dimension(56, 20));
        bQuantiles.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bQuantiles.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauChoro.add(bQuantiles);

        bVerts.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bVerts.setText(Messages.getString("PanneauDroite.11")); //$NON-NLS-1$
        bVerts.setBackground(new java.awt.Color(204, 255, 255));
        bVerts.setPreferredSize(new java.awt.Dimension(56, 20));
        bVerts.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bVerts.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauChoro.add(bVerts);

        bMoyemb.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bMoyemb.setText(Messages.getString("PanneauDroite.13")); //$NON-NLS-1$
        bMoyemb.setBackground(new java.awt.Color(204, 255, 255));
        bMoyemb.setPreferredSize(new java.awt.Dimension(56, 20));
        bMoyemb.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bMoyemb.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauChoro.add(bMoyemb);

        bGris.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bGris.setText(Messages.getString("PanneauDroite.15")); //$NON-NLS-1$
        bGris.setBackground(new java.awt.Color(204, 255, 255));
        bGris.setPreferredSize(new java.awt.Dimension(56, 20));
        bGris.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bGris.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauChoro.add(bGris);

        this.add(panneauChoro);

        panneauSymb.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        panneauSymb.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        panneauSymb.setBackground(new java.awt.Color(0, 204, 204));
        panneauSymb.setPreferredSize(new java.awt.Dimension(130, 190));
        labelSymb.setText(Messages.getString("PanneauDroite.16")); //$NON-NLS-1$
        labelSymb.setForeground(new java.awt.Color(0, 51, 51));
        labelSymb.setBackground(new java.awt.Color(204, 204, 255));
        labelSymb.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        labelSymb.setPreferredSize(new java.awt.Dimension(120, 23));
        labelSymb.setOpaque(true);
        panneauSymb.add(labelSymb);

        sliderSymb.setMinorTickSpacing(1);
        sliderSymb.setPaintLabels(true);
        sliderSymb.setPaintTicks(true);
        sliderSymb.setMajorTickSpacing(1);
        sliderSymb.setMaximum(10);
        sliderSymb.setForeground(new java.awt.Color(51, 51, 0));
        sliderSymb.setBackground(new java.awt.Color(204, 255, 255));
        sliderSymb.setValue(5);
        sliderSymb.setFont(new java.awt.Font("Dialog", 1, 12)); //$NON-NLS-1$
        sliderSymb.setPreferredSize(new java.awt.Dimension(120, 45));
        panneauSymb.add(sliderSymb);

        bCercles.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bCercles.setText(Messages.getString("PanneauDroite.19")); //$NON-NLS-1$
        bCercles.setBackground(new java.awt.Color(204, 255, 255));
        bCercles.setPreferredSize(new java.awt.Dimension(56, 20));
        bCercles.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bCercles.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauSymb.add(bCercles);

        bCarres.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bCarres.setText(Messages.getString("PanneauDroite.21")); //$NON-NLS-1$
        bCarres.setBackground(new java.awt.Color(204, 255, 255));
        bCarres.setPreferredSize(new java.awt.Dimension(56, 20));
        bCarres.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bCarres.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauSymb.add(bCarres);

        bPLineaire.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bPLineaire.setText(Messages.getString("PanneauDroite.23")); //$NON-NLS-1$
        bPLineaire.setBackground(new java.awt.Color(204, 255, 255));
        bPLineaire.setPreferredSize(new java.awt.Dimension(119, 20));
        bPLineaire.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bPLineaire.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauSymb.add(bPLineaire);

        bPRacine.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bPRacine.setText(Messages.getString("PanneauDroite.25")); //$NON-NLS-1$
        bPRacine.setBackground(new java.awt.Color(204, 255, 255));
        bPRacine.setPreferredSize(new java.awt.Dimension(119, 20));
        bPRacine.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bPRacine.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauSymb.add(bPRacine);

        bPLog.setFont(new java.awt.Font("Dialog", 1, 10)); //$NON-NLS-1$
        bPLog.setText(Messages.getString("PanneauDroite.27")); //$NON-NLS-1$
        bPLog.setBackground(new java.awt.Color(204, 255, 255));
        bPLog.setPreferredSize(new java.awt.Dimension(119, 20));
        bPLog.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        bPLog.setMargin(new java.awt.Insets(0, 0, 0, 0));
        panneauSymb.add(bPLog);

        this.add(panneauSymb);

    }

    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
    
    }

    public javax.swing.JSlider sliderSymb;

    public javax.swing.JPanel panneauSymb;

    public javax.swing.JSlider sliderChoro;

    public javax.swing.JPanel panneauChoro;

    public javax.swing.JButton bVerts;

    public javax.swing.JButton bCercles;

    public javax.swing.JButton bQuantiles;

    public javax.swing.JLabel labelChoro;

    public javax.swing.JButton bGris;

    public javax.swing.JLabel labelSymb;

    public javax.swing.JButton bCarres;

    public javax.swing.JButton bMoyemb;

    public javax.swing.JLabel labelselect;

    public javax.swing.JButton bRouges;

    public javax.swing.JButton bPLog;

    public javax.swing.JButton bPLineaire;

    public javax.swing.JButton bDefaut;

    public javax.swing.JTextField tfSelect;

    public javax.swing.JButton bPRacine;
}