/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.AffineTransform;

import javax.swing.JInternalFrame;

import carto.FondCarte;

/**
 * @author Laurent
 *  
 */
public class goCarte extends GraphicObject {

    private FondCarte fondCarte;

    private double coef;
    
    private double coefMEP = 0;

	private int larg1;

	private int haut1;
	
    //Constructeurs

    public goCarte() {
        super();
        this.setType("Carte"); //$NON-NLS-1$
    }

    /**
     * @param position
     * @param size
     * @param fondCarte
     */
    public goCarte(Point position, Dimension size, FondCarte fondCarte) {
        super(position, size);
        this.setType("Carte"); //$NON-NLS-1$
        this.fondCarte = fondCarte;
        coef = calculCoeff(this.getWidth(), this.getHeight(), fondCarte);
    }

    //Fonctions

    /**
     * @return Returns the fondCarte.
     */
    public FondCarte getFondCarte() {
        return fondCarte;
    }

    /**
     * @param fondCarte
     *            The fondCarte to set.
     */
    public void setFondCarte(FondCarte fondCarte) {
        this.fondCarte = fondCarte;
    }

    public void draw(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        AffineTransform oatx = g2.getTransform();
        g2.rotate(this.getRotation());
        g2.translate(this.getX(), this.getY());
        fondCarte.setPourMEP(true);
        fondCarte.calculerCoord(0, 0, coef);
      	if (coefMEP == 0) coefMEP = calculeCoefMEP();
        fondCarte.setCoefMEP(coefMEP);
        fondCarte.drawFondCarte(g);
        fondCarte.setPourMEP(false);
        g2.setTransform(oatx);
    }

    //Fonction qui calcule le coefficient utilisé pour redimensionner la carte
    public double calculCoeff(int inputWidth, int inputHeight, FondCarte fondCarte) {
        double coeffX = ((double) inputWidth) / fondCarte.getLargeur();
        double coeffY = ((double) inputHeight) / fondCarte.getHauteur();
        if (coeffX > coeffY) {
        	this.setWidth((int) (fondCarte.getLargeur() * coeffY));
            return coeffY;
        } else {
        	this.setHeight((int) (fondCarte.getHauteur() * coeffX));
            return coeffX;
        }
    }

    public double calculeCoefMEP() {
    	double[] extremes = fondCarte.trouverLimites();
    	double largeurE = extremes[2] - extremes[0];
    	double hauteurE = extremes[3] - extremes[1];
        double c1 = Math.sqrt(Math.abs((this.getHeight() * this.getWidth()) / (hauteurE * largeurE)));
    	double coeffX = Math.abs(this.getWidth() / largeurE) / c1;
        double coeffY = Math.abs(this.getHeight() / hauteurE) / c1;
		if (coeffX < coeffY) {
			return coeffX;
		} else {
			return coeffY;
		}
    }
}