package guiInterface;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.geom.AffineTransform;
public class goEchelle extends GraphicObject {

	int m_kms = 0;
	
	public goEchelle(Point position, Dimension size, int kms) {
		super(position, size);
		this.m_kms = kms;
	}

	public goEchelle(int posX, int posY, Dimension size, int kms) {
		super(posX, posY, size);
		this.m_kms = kms;
	}

	public goEchelle(int posX, int posY, int width, int height, int kms) {
		super(posX, posY, width, height);
		this.m_kms = kms;
	}

	public goEchelle(Point position, Dimension size, int kms, double rotation) {
		super(position, size, rotation);
		this.m_kms = kms;
	}

	public goEchelle(int posX, int posY, int width, int height, int kms, double rotation) {
		super(posX, posY, width, height, rotation);
		this.m_kms = kms;
	}

    public void draw(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        Paint originePaint = g2.getPaint();
        AffineTransform oatx = g2.getTransform();
        g2.rotate(this.getRotation());
        g2.setPaint(Color.black);
        g2.drawLine(this.getX(), this.getY() + 5, this.getX(), this.getY());
        g2.drawLine(this.getX(), this.getY() + 5, this.getX() + this.getWidth(), this.getY() + 5);
        g2.drawLine(this.getX() + this.getWidth(), this.getY() + 5, this.getX() + this.getWidth(), this.getY());
        g2.drawString("0", this.getX() - 2, this.getY() - 5);
        g2.drawString(String.valueOf(this.m_kms) + " km", this.getX() + this.getWidth() - 5, this.getY() - 5);
        g2.setPaint(originePaint);
        g2.setTransform(oatx);
    }
	
}
