/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.Point;
import java.awt.geom.AffineTransform;

/**
 * @author Laurent
 *  
 */
public class goLegende extends GraphicObject {

    private PanneauLegende legende;
    
    private double coefMEP = 0;

    //Constructeur
    public goLegende(Point position, Dimension size, PanneauLegende legende) {
        super(position, size);
        this.setType("Legende"); //$NON-NLS-1$
        this.legende = legende;
        this.setWidth(legende.getWidth());
        this.setHeight(legende.getHeight());
    }

    public void draw(Graphics g) {
        if (legende.getFond().getCoefMEP() == 0)
        	return;
        Graphics2D g2 = (Graphics2D) g;
        Paint originePaint = g2.getPaint();
        AffineTransform oatx = g2.getTransform();
        g2.rotate(this.getRotation());
        g2.translate(this.getX(), this.getY());
        g2.setPaint(Color.black);
        legende.getFond().setPourMEP(true);
        legende.paint(g);
        legende.getFond().setPourMEP(false);
        g2.setTransform(oatx);
        g2.setPaint(originePaint);        
    }

}