/*
 * 8 avril 2007
 * 
 * SCALP - Système de Cartographie Automatique Libre pour la Pédagogie
 * Version beta 0.94
 *
 * Copyright 1997-2007 Université de Toulouse Le Mirail / Département de Géographie / Laurent Jégou
 * Portions : 	Copyright (c) 2004 Sun Microsystems (file filter, AbstractLayout)
 * 				Copyright 1999, 2000, 2001, 2002 by Bruno Lowagie (iText pdf exports)
 * 				Copyright (C) 2001 Andrew Khan (jxl import/export format Excelé)
 * http://www.univ-tlse2.fr/geoprdc
 * jegou@univ-tlse2.fr
 * 
 * Ce programme est un logiciel libre régi par la licence CeCILL (cf. lien ci-dessous), cette licence confére
 * aux utilisateurs la liberté de modification et de redistribution du logiciel, dans le cadre d'un modéle de
 * diffusion open-source.
 * L'exercice de ces libertés est assorti de certains devoirs é la charge des utilisateurs afin de préserver
 * ce statut au cours des redistributions ultérieures.
 * Léaccessibilité au code source et les droits de copie, de modification et de redistribution qui en découlent
 * ont pour contrepartie de néoffrir aux utilisateurs quéune garantie limitée et de ne faire peser sur léauteur
 * le titulaire des droits patrimoniaux et les concédants successifs quéune responsabilité restreinte.
 * 
 * Le texte intégral de la licence se trouve dans la disribution, ou é l'adresse suivante :
 * http://www.cecill.info
 */

package guiInterface;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.AffineTransform;

/**
 * @author Laurent
 * 
 */

public class goTexte extends GraphicObject {

    protected Font m_font;

    protected String m_texte;

    protected Color m_couleur;

    //Constructeurs

    public goTexte(Point position, String texte) {
        super(position);
        this.m_autoSize = true;
        this.m_texte = texte;
        this.m_type = "texte"; //$NON-NLS-1$
    }

    public goTexte(Point position, String texte, Font fonte, Color couleur) {
        super(position);
        this.m_autoSize = true;
        this.m_texte = texte;
        this.m_font = fonte;
        this.m_couleur = couleur;
    }

    /**
     * @return Returns the m_couleur.
     */
    public Color getCouleur() {
        return m_couleur;
    }

    /**
     * @param m_couleur
     *            The m_couleur to set.
     */
    public void setCouleur(Color m_couleur) {
        this.m_couleur = m_couleur;
    }

    /**
     * @return Returns the m_font.
     */
    public Font getFont() {
        return m_font;
    }

    /**
     * @param m_font
     *            The m_font to set.
     */
    public void setFont(Font m_font) {
        this.m_font = m_font;
    }

    /**
     * @return Returns the m_texte.
     */
    public String getTexte() {
        return m_texte;
    }

    /**
     * @param m_texte
     *            The m_texte to set.
     */
    public void setTexte(String m_texte) {
        this.m_texte = m_texte;
    }

    public void draw(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        AffineTransform oatx = g2.getTransform();
        g2.rotate(this.getRotation());
        g2.setFont(this.getFont());
        g2.setColor(this.getCouleur());
        if (this.getAutoSize() == true) {
            double largeur = g2.getFontMetrics().getStringBounds(this.getTexte(), g).getWidth();
            double hauteur = g2.getFontMetrics().getStringBounds(this.getTexte(), g).getHeight();
            this.setWidth((int) largeur);
            this.setHeight((int) hauteur);
            g2.drawString(this.getTexte(), this.getX(), this.getY() + this.getHeight());
        } else {
            g2.drawString(this.getTexte(), this.getX(), this.getY() + this.getHeight());
        }
        g2.setTransform(oatx);
    }

    /*
     * public void drawSVG(SVGDocument svgDoc) { //A compléter. }
     */
}